#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#ifdef QDOS
# define swapword(p1) (p1)
typedef unsigned short ushort;
#else
static ushort inline swapword (ushort val)
{
    return (ushort) (val << 8) + (val >> 8);
}
#endif

typedef struct
{
    ushort flag;
    short xpix;
    short ypix;
    short llen;
    short mode;
} QHEAD;

int main(int ac, char **av)
{
    char *op =NULL, *ip = NULL;
    int fd;
    FILE *fp;
    QHEAD qh;
    short xpix = 0, ypix = 0,llen = 0, qlen;
    short i,j,k;
    char *obuf,*nbuf;
    short ar = 0;
    

    if(ac > 3)
    {
	fputs("pbm2pic infile outfile [ar]\n", stderr);
	fputs("        if ar is anything, then the output file is\n", stderr);
	fputs("        mutilated for QDOS pixel ratios\n", stderr);
	return 0;
    }
    
    ip = *(av + 1);
    op = *(av + 2);

    ar = (ac == 4);
    
    if (ip && op && (fp = fopen (ip, "r")))
    {
	char sfn[256], *sp;
	for (i = 0; i < 2;)
	{
	    fgets (sfn, sizeof (sfn), fp);
	    if (*sfn == '#')
	    {
		char *ap;
		if((ap = strchr(sfn, '\n')))
		{
		    *ap = 0;
		}
	    }
	    else
	    {
		if (i == 0)
		{
		    if (strncmp (sfn, "P4", 2))
		    {
			fclose (fp);
			puts ("Not a PBM file");
			return 0;
		    }
		    else
		    {
			i++;
		    }
		}
		else if (i == 1)
		{
		    xpix = strtol (sfn, &sp, 10);
		    ypix = strtol (sp, NULL, 10);
		    llen = (xpix + 7) >> 3;
		    i = 2;
		}
	    }
	}

	qlen = llen*2 + 4;
	if((fd = open(op, O_CREAT|O_TRUNC|O_WRONLY), 0666) > 0)
	{
	    short yp = 0;
	    
	    write(fd, &qh, sizeof(qh));
	    obuf = malloc(llen);
	    nbuf = calloc(qlen,1);

	    for(i = 0; i < ypix; i++)
	    {
		fread (obuf, llen, 1, fp);
		if(ar ==0 || ((i+1) & 3))
		{
		    for(k = j = 0; j < llen ;j++, k +=2)
		    {
			nbuf[k] = nbuf[k+1] = ~obuf[j];
		    }
		    write (fd, nbuf, qlen);
		    yp++;
		}
	    }
	    lseek(fd, 0, 0);
	    qh.flag = swapword((ushort)0x4afc); 
	    qh.xpix = swapword(xpix); 
	    qh.ypix = swapword(yp); 
	    qh.llen = swapword(qlen); 
	    qh.mode = 0;
	    write(fd, &qh, sizeof(qh));	    
	}
    }
    return 0;
}
